<?php
	/*'*************************************************\
	 	Copyright (C) 2001, Alexey Ilyin

	 	This library is free software; you can
		redistribute it and/or modify it under the terms
		of the GNU Lesser General Public License as
		published by the Free Software Foundation; either
		version 2.1 of the License, or (at your option)
		any later version.

	 	This library is distributed in the hope that it
		will be useful, but WITHOUT ANY WARRANTY; without
		even the implied warranty of MERCHANTABILITY or
		FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
		Lesser General Public License for more details.

	 	You should have received a copy of the GNU Lesser
		General Public License along with this library; if
		not, write to the Free Software Foundation, Inc.,
		59 Temple Place, Suite 330, Boston, MA 02111-1307
		USA

	 	ai@a4web.com
	 	www.a4web.com
	\**************************************************/

	require_once	"ccontrol.phps";

	/** The CForm control for file uploading.
	 * 	<xmp>
	 |	new CFile(array(
	 |		"label"	=> ...,
	 |		"do"	=> $DO,
	 |		"upload_dir" => "$DOCUMENT_ROOT/upload/"
	 |	))
	 * 	</xmp>
	 * 	@package	PHP/Toolbox::Form
	 */
	class CCFile extends CControl {
		var $type = "file";
		var $abs_path = "/tmp";
		var	$upload_dir = "";
		/**	The operation:
		 * 	<pre><ul>
		 * 	<li> INS	- insert a record
		 * 	<li> EDIT	- modify a record
		 * 	<li> DEL	- delete a record
		 * 	</ul></pre>
		 */
		var $do = "";

		function CCFile ($attrs) {
			$this->CControl($attrs);
		}

		function render () {
			$value = $this->getValue();
			$this->write("<input type='file' name='{$this->name}_tmp' $this->attrs>");
			$this->write("<input type='hidden' name='$this->name' value='$value'>");
		}

		/*function renderReadonly () {
			$this->write();
		}/***/

		function outValue () {
			$oldfile = "$this->name";
			$tmpfile = "{$oldfile}_tmp";
			global $$oldfile, $$tmpfile;
			$this->doUploadFile ($tmpfile, $oldfile, $this->abs_path, $this->upload_dir);
			//PHPX_DEBUG("out:\t${$tmpfile}, ${$oldfile}");
			return $$oldfile;
		}

		/**	Accepts uploaded file
		 * 	and moves it to permanent location.
		 */
		function acceptUpload ($tmpfile, $oldfile, $abs_path, $upload_dir) {
			global $$oldfile, $$tmpfile;
			if ($$tmpfile !== "none") {	//	MAGIC!
				//	get source file extension
				$srcname = "{$tmpfile}_name";
				global $$srcname;
    			$tmp = explode(".", $$srcname);
				$ext = end($tmp);
				//	get destination file name
				$tmp = explode("/", $$tmpfile);
				$file_name = $upload_dir.end($tmp).".$ext";
				//
				if (move_uploaded_file($$tmpfile, $abs_path.$file_name)) {
					return $file_name;
				}
			}
			return FALSE;
		}

		/**	Performs the file uploading and database operation logic.
		 */
		function doUploadFile ($tmpfile, $oldfile, $abs_path, $upload_dir) {
			global $$oldfile, $$tmpfile;
			//PHPX_DEBUG("in:\t${$tmpfile}, ${$oldfile}, $abs_path, $upload_dir");
			if ($$tmpfile !== "none") {	//	MAGIC!
				switch ($this->do) {
				case "INS" :
				case "EDIT" :
					$newfile = $this->acceptUpload($tmpfile, $oldfile, $abs_path, $upload_dir);
					if ($newfile) {
						if ($$oldfile && !@unlink($abs_path.$$oldfile)) {
							log_message($$oldfile." can not be deleted.", TRUE);
						}
						$$oldfile = $newfile;
					}
					break;
				case "DEL":
					if ($$oldfile && !@unlink($abs_path.$$oldfile)) {
						log_message($$oldfile." can not be deleted.", TRUE);
					}
					break;
				}
			}
			//phpx_debug($GLOBALS);
		}
	}
?>