<?php
	/*'*************************************************\
		PHP4/X
		cdbtable.phps
	 ****************************************************
	 	Copyright (C) 2001, Alexey Ilyin

	 	This library is free software; you can
		redistribute it and/or modify it under the terms
		of the GNU Lesser General Public License as
		published by the Free Software Foundation; either
		version 2.1 of the License, or (at your option)
		any later version.

	 	This library is distributed in the hope that it
		will be useful, but WITHOUT ANY WARRANTY; without
		even the implied warranty of MERCHANTABILITY or
		FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
		Lesser General Public License for more details.

	 	You should have received a copy of the GNU Lesser
		General Public License along with this library; if
		not, write to the Free Software Foundation, Inc.,
		59 Temple Place, Suite 330, Boston, MA 02111-1307
		USA

	 	ai@a4web.com
	 	www.a4web.com
	\**************************************************/

	error_reporting(7);

	require_once	"csplitbar.phps";

	//	get rid of operations from INS, EDIT, DEL
	$QUERY_STRING = query_string(array("DO"=>"","WHERE"=>""));

	//echo @base64_decode($WHERE); //DEBUG//

	/**	The basic html table snippet class
	 * 	that is db-driven as well as CDBForm.
	 * 	The class creates the table <em>rows</em> with
	 * 	<ul>
	 * 	<li>	the split bar that allows table pagination;
	 * 	<li>	the header that allows sorting by given field in ascending/descending order;
	 * 	<li>	the insert text 'button' that invokes the edit script;
	 * 	<li>	the set of data rows followed by edit/delete text 'buttons' that also invokes the edit script.
	 * 	</ul>
	 * 	<xmp>
	 |	$table = new CDBTable("T1",
	 |		"select * from table_1",
	 |		array(
	 |			"FIELD_DESCR" => array(
	 |				new CField(array(
	 |					...
	 |				)),
	 |				...
	 |			),
	 |			...
	 |		)
	 |	);
	 |	...
	 |	$table->render();
	 * 	</xmp>
	 * 	The presentation is controlled by CSS:
	 * 	<pre><ul>
	 * 	<li> .navbar	- navigator (splitbar) class
	 * 	<li> .header	- the table header class
	 * 	<li> .headN 	- column N header class (N=0..field_count)
	 * 	<li> .colN		- column N class
	 * 	<li> .row1/row2	- odd/even rows classes
	 * 	<li> .edit		- edit/delete text 'buttons' class
	 * 	<li> .null		- null value class
	 * 	</ul></pre>
	 * 	@package	PHP/Toolbox::Table
	 */
	class CDBTable
	extends CSplitBar
	{
		var	$QUERY = "";
		var	$SORTING = TRUE;
		var	$EDITBAR = "<EDIT>&nbsp;Edit&nbsp;</EDIT>|<DEL>&nbsp;Del&nbsp;</DEL>";
		var	$INSBAR = "<INS>&nbsp;Insert&nbsp;</INS>";
		/**	Script file that provides the record editing functionality.
		 *	Note that conctructor sets this field to $PHP_SELF by default.
		 * 	@see CDBTable()
		 * 	@see CForm
		 */
		var $FORMFILE = "edit.php";
		var $FIELD_DESCR = array();

		/**	Constructs the table:
		 * 	@param	string
		 * 	@param	string	- sql-statement to get the data.
		 * 	@param	array	- optional fields (see CSnippet).
		 * 	@see	$SORTING, $EDITBAR, $INSBAR, $FORMFILE
		 * 	@see	CSnippet
		 */
		function CDBTable ($id, $QUERY, $attrs = array()) {
			$this->id	= $id;
			$this->QUERY = $QUERY;
			global $PHP_SELF;
			$this->FORMFILE = $PHP_SELF;
			$this->CSnippet($attrs);
		}

		function render () {
			$SORT = $this->qualify("sort");
			$SDIR = $this->qualify("sdir");
			global	$$SORT, $$SDIR;

			$this->do_query_size();
			$this->do_query_page($rset, $$SORT, $$SDIR);
			$this->fetch_fields($rset);

			$navstr = "<tr><td class=navbar align=right colspan=100>$this->navstr</td></tr>\n";
			if ($this->PAGECOUNT > 1) $this->write($navstr);
			$this->write("<tr class='header'>\n<th class=head0 width=0%>&nbsp;</th>\n");

			#//////	PRINT TABLE HEADER /////#

			reset($this->fields);
			while (list($col,$field) = each($this->fields)) {
				$name = $fname = $field->name;
				$fd = @$this->FIELD_DESCR[$fname];
				if ($fd) {
					if (@$fd->ignore) continue;
					if (@$fd->name) $name = $fd->name;
				}
				$this->write("<th class=head$col");
				if ($field->numeric) $this->write(" align=right");
				$this->write(">");
				if ($this->SORTING) {
					$this->write(
						"<a href='$PHP_SELF?".query_string(array(
							$SORT => $fname,
							$SDIR => $fname == $$SORT ? !$$SDIR : $fd->defsort
						))."' $fd->extra>$name</a>"
					);
				}
				else {
					$this->write("$name");
				}
				$this->write("</th>\n");
			}
			//	put 'insert' at the end of the header
			if ($this->INSBAR) {
				$this->write("<td class=edit>");
				$insstr = $this->subst_globals($this->INSBAR);
				$insstr = str_replace("<INS>",
					"<a href='$this->FORMFILE?".query_string(array("T"=>$this->id,"DO"=>"INS"))."'>",
					$insstr
				);
				$insstr = str_replace("</INS>", "</a>", $insstr);
				$this->write("$insstr</td>");
			}
			$this->write("</tr>\n");

			#//////	PRINT ROWS //////#

			if ($this->TOTROWS) {
				for ($rn = 0; fetch_record($rset, $rec); $rn++) {
					$this->write( "<tr class=row".(($rn & 1) + 1).">\n" );
					$this->write( "<td align=right class=col0 width=0%>".($this->PGOFFS + $rn)."</td>\n" );
					$where = array(); reset($this->fields);
					//////	enumerate fields  //////
					while (list($col, $field) = each($this->fields)) {
						/*------------------------------*/
						$fname = $field->name;
						$value = $rec[$fname];
						$fd = @$this->FIELD_DESCR[$fname];
						if ($fd->primary || $field->primary_key) {
							$where[] = "$field->table.$fname='$value'";
						}
						$value = htmlspecialchars($value);
						/*------------------------------*/
						if ($fd->ignore) continue;
						$this->write( "<td" );
						if ($field->numeric) $this->write( " align=right" );
						$this->process_specially ($fd, $value);
						$this->write ( @$value != "" ?
							" class=col$col $fd->extra>$value</td>\n" :
							" class=null $fd->extra>&nbsp;</td>\n"
						);
					}
					//////	setup the links  //////
					if ($where) {
						$qstr = $this->identify ($where);
						if ($this->EDITBAR) {
							$this->write( "<td class=edit>" );
							$editstr = $this->subst_globals($this->EDITBAR);
							$editstr = str_replace("<EDIT>", "<a href='$this->FORMFILE?DO=EDIT&$qstr'>", $editstr);
							$editstr = str_replace("<DEL>",  "<a href='$this->FORMFILE?DO=DEL&$qstr'>", $editstr);
							$editstr = ereg_replace("</(EDIT|DEL)>", "</a>", $editstr);
							$this->write( "$editstr</td>\n" );
						}
					}
					elseif ($this->INSBAR) {
						$this->write( "<td class=edit>&nbsp;</td>" );
					}
					//////	close the row  //////
					$this->write( "</tr>\n" );
					$this->flush();
				}

				#//////	PRINT THE FOOTER AND FINISH //////#

				if ($this->PAGECOUNT > 1) $this->write( $navstr );
				//else $this->write("<tr class=header><td colspan=100>&nbsp;</td></tr>");
			}
			else {
				$this->write("<tr><td colspan=100>".@EMPTY_QUERY."</td></tr>\n");
			}
			//	cleanup
			@free_result($rset);
			$this->navstr = 0;
		}/*render*/

		/**	Queries the dataset size.
		 * 	Use it to get this size in advance.
		 * 	@param	string	- if it is NOT set then TOTROWS just recalculated,
		 * 					otherwise new sql-statement and field set is set up as well.
		 * 	@return	int	- TOTROWS
		 * 	@see	$TOTROWS
		 * 	@access	public
		 */
		function do_query_size ($QUERY = "") {
			if ($QUERY) {
				$this->QUERY = $QUERY;
				$this->fields = array();
			}
			//if (!$this->fields) {  // currently doesn't work :(
				if (ereg("select.*from", $this->QUERY)) {
					$rset = do_query(ereg_replace("select.*from", "select count(*) from", $this->QUERY));
					fetch_record($rset, $rec);
					$this->TOTROWS = @current($rec);
				}
				else {
					$rset = do_query($this->QUERY);
					$this->TOTROWS = rset_rows($rset);
				}
				free_result($rset);
				$this->navstr = CSplitBar::render();
				$this->PAGECOUNT = @ceil($this->TOTROWS/$this->PAGESIZE);
			//}
			return $this->TOTROWS;
		}

		/**	Queries the page.
		 * 	@param	int 	- out recordset.
		 * 	@param	string	- sorting field
		 * 	@param	bool	- sorting direction (descendant if TRUE).
		 * 	@return	int 	- recordset.
		 */
		function do_query_page (&$rset, $sort, $sdir) {
			$sql = $this->QUERY;
			if ($sort) $sql .= " order by ".$sort;
			if ($sdir) $sql .= " desc";
			if ($this->PAGECOUNT > 1)
				$sql .= " limit ".($this->PGOFFS-1).", $this->PAGESIZE";
			return $rset = do_query ($sql);
		}

		/**	Fetches the field set (meta-info)
		 * 	from given recordset.
		 * 	@param	int - recordset.
		 * 	@return	int	- field count.
		 */
		function fetch_fields ($rset) {
			if (!$this->fields) {
				for ($i=0; fetch_field($rset, $field, $i); $i++) {
					$this->fields[$field->name] = $field;
				}
			}
			return count($this->fields);
		}

		/**	Returns http query string that identifies the dataset row.
		 * 	@param	array	- 'where' clause condition list.
		 * 	@return	string	- http query string
		 */
		function identify ($where) {
			return query_string(array("T"=>$this->id, "WHERE"=>urlencode(base64_encode(join(" and ", $where)))));
		}

		/**	Performs the custom processing of field value.
		 * 	Use it to override the default behavior that is
		 * 	the invokation of field descriptor process method.
		 * 	@see	CField.
		 */
		function process_specially (&$fd, &$value) {
			if (is_object($fd)) $fd->process($value);
		}
	}/*CTable*/
?>