<?php
	/*'************************************************\
	 	Copyright (C) 2001, Alexey Ilyin

	 	This library is free software; you can
		redistribute it and/or modify it under the terms
		of the GNU Lesser General Public License as
		published by the Free Software Foundation; either
		version 2.1 of the License, or (at your option)
		any later version.

	 	This library is distributed in the hope that it
		will be useful, but WITHOUT ANY WARRANTY; without
		even the implied warranty of MERCHANTABILITY or
		FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
		Lesser General Public License for more details.

	 	You should have received a copy of the GNU Lesser
		General Public License along with this library; if
		not, write to the Free Software Foundation, Inc.,
		59 Temple Place, Suite 330, Boston, MA 02111-1307
		USA

	 	ai@a4web.com
	 	www.a4web.com
	\**************************************************/

	require_once "cselect.phps";

	/** The cform group (of radio- or check-boxes) ccontrols.
	 * 	<xmp>
	 |	new CGroup(array(
	 |		"label" => ...,
	 |		"options" => ...
	 |	))
	 * 	</xmp>
	 * 	@see		$options
	 * 	@package	PHP/Toolbox::Form
	 */
	class CGroup extends CSelect {
		var	$type = "group";
		/**	The html-formatting suffix of the group's item.
		 */
		var $suffix = "&nbsp;";

		function CGroup ($attrs) {
			$this->CSelect($attrs);
		}

		function render () {
			if (count($this->options) > $this->sizeThreshold) {
				CSelect::render();
				return;
			}
			$variable = $this->getValue();
			$multiple = $this->multiple === "auto" ? is_array($variable) : $this->multiple;
			$type = $multiple ? "checkbox" : "radio";
			foreach ($this->options as $label => $value) {
				//PHPX_DEBUG("$label=>$value");
				if (is_int($label)) $label = $value;
				$selected = $multiple ? @in_array($value, $variable) : $value == $variable;
				$this->write(
					"<input type='$type' name='$this->name".($multiple ? "[]" : "")."' value='$value'"
					.($selected ? " checked" : "")." $this->attrs>$label$this->suffix"
				);
			}
		}
	}
?>