<?php
	/*'************************************************\
	 	Copyright (C) 2001, Alexey Ilyin

	 	This library is free software; you can
		redistribute it and/or modify it under the terms
		of the GNU Lesser General Public License as
		published by the Free Software Foundation; either
		version 2.1 of the License, or (at your option)
		any later version.

	 	This library is distributed in the hope that it
		will be useful, but WITHOUT ANY WARRANTY; without
		even the implied warranty of MERCHANTABILITY or
		FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
		Lesser General Public License for more details.

	 	You should have received a copy of the GNU Lesser
		General Public License along with this library; if
		not, write to the Free Software Foundation, Inc.,
		59 Temple Place, Suite 330, Boston, MA 02111-1307
		USA

	 	ai@a4web.com
	 	www.a4web.com
	\**************************************************/

	require_once "cfield.phps";

	/** The table field that provides scaled image representation.
	 * 	<xmp>
	 | 	new CImageField(array(
	 | 		"size"	=> ...,
	 | 		"attrs"	=> "align=left",
	 | 		...
	 | 	))
	 * 	</xmp>
	 * 	@package	PHP/Toolbox::Table
	 */
	class CImageField extends CField {
		/**	If it is set image is fitted to square area
		 * 	[size x size].
		 */
		var $size = 100;
		/**	The image area width. */
		var	$width;
		/**	The image area height. */
		var	$height;

		function CImageField ($args) {
			$this->CField($args);
		}

		/**	Special processing for image fields. */
		function process (&$value) {
			global $DOCUMENT_ROOT;
			$value = split("[:;,]", $value);
			$value = $value[0];
			$value = "<img src='$value' ".(isset($this->size) ?
				ImgScale($DOCUMENT_ROOT.$value, $this->size, $this->size) :
				ImgScale($DOCUMENT_ROOT.$value, $this->width, $this->height)
			).@$this->attrs.">";
		}
	}
?>