<?php
	/*'************************************************\
	 	Copyright (C) 2001, Alexey Ilyin

	 	This library is free software; you can
		redistribute it and/or modify it under the terms
		of the GNU Lesser General Public License as
		published by the Free Software Foundation; either
		version 2.1 of the License, or (at your option)
		any later version.

	 	This library is distributed in the hope that it
		will be useful, but WITHOUT ANY WARRANTY; without
		even the implied warranty of MERCHANTABILITY or
		FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
		Lesser General Public License for more details.

	 	You should have received a copy of the GNU Lesser
		General Public License along with this library; if
		not, write to the Free Software Foundation, Inc.,
		59 Temple Place, Suite 330, Boston, MA 02111-1307
		USA

	 	ai@a4web.com
	 	www.a4web.com
	\**************************************************/

	require_once	"csnippet.phps";

	/**	Basic form markup class.
	 * 	<xmp>
	 *	$form->addControl(NO_INDEX, new CMarkup("<td>"));
	 * 	</xmp>
	 * 	@package	PHP/Toolbox::Form
	 */
	class  CMarkup extends CSnippet {
		var	$attrs = "";
		var $nodata = TRUE;

		/**	Constructor.
		 * 	@param	mixed	- you can specify it as an array (us usual for CSnippet)
		 * 					or just string as well. In latter case the specified string
		 * 					just appended to html-tag as attribute string:
		 * 					<xmp>
		 * 					<tag attrs>
		 * 					</xmp>
		 * 					If you need to specify it together with other fields you have to
		 * 					append it to array, e.g.:
		 * 					<br><code>
		 * 					array("field"=>$value, <b>"attrs"=>"nowrap"</b>)
		 * 					</code><br>
		 * 					Note that it is inherited by all ccontrols and cbutton as well.
		 * 	@see	CControl, CButton
		 */
		function CMarkup ($attrs = "") {
			if (is_string($attrs)) {
				$this->attrs = $attrs;
			}
			else {
				$this->CSnippet($attrs);
			}
		}

		function render () {
			$this->write($this->attrs);
		}

		function renderReadonly () {
			$this->render();
		}

		//function write ($s) {echo "$s\n";} //DEBUG//
	}
?>