<?php
	/*'************************************************\
	 	Copyright (C) 2001, Alexey Ilyin

	 	This library is free software; you can
		redistribute it and/or modify it under the terms
		of the GNU Lesser General Public License as
		published by the Free Software Foundation; either
		version 2.1 of the License, or (at your option)
		any later version.

	 	This library is distributed in the hope that it
		will be useful, but WITHOUT ANY WARRANTY; without
		even the implied warranty of MERCHANTABILITY or
		FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
		Lesser General Public License for more details.

	 	You should have received a copy of the GNU Lesser
		General Public License along with this library; if
		not, write to the Free Software Foundation, Inc.,
		59 Temple Place, Suite 330, Boston, MA 02111-1307
		USA

	 	ai@a4web.com
	 	www.a4web.com
	\**************************************************/

	require_once	"ccontrol.phps";

	/** The form selection ccontrol.
	 * 	<xmp>
	 |	new CSelect(array(
	 |		"label" => ...,
	 |		"options" => ...
	 |	))
	 * 	</xmp>
	 * 	@see	$options
	 * 	@package	PHP/Toolbox::Form
	 */
	class CSelect extends CControl {
		var	$type = "select";
		/**	If multiple === "auto" then 'multiple' tag attribute is generated automatically.
		 * 	It appears if the value of control's variable is array.
		 */
		var	$multiple = "auto";
		/**	Specify options as
		 * 	<ul>
		 * 	<li>	array("label"=>"value",...)
		 * 	<li>	array("value",...)
		 * 	<li>	"value|..."
		 * 	<ul>
		 */
		var $options; // DO NOT USE = array();
		/**	??? */
		var	$sizeThreshold = 8;

		/**	Constructor.
		 */
		function CSelect ($attrs) {
			$this->CControl($attrs);
			if (is_string(@$this->options)) {
				$this->options = split("\|", $this->options);
			}
		}

		function render () {
			$variable = $this->getValue();
			$multiple = $this->multiple === "auto" ? is_array($variable) : $this->multiple;
			$this->write("<select name='$this->name".($multiple ? "[]' multiple" : "'")." $this->attrs>");
			foreach ($this->options as $label => $value) {
				//PHPX_DEBUG("$label=>$value");
				if (is_int($label)) $label = $value;
				$selected = $multiple ? @in_array($value, $variable) : $value == $variable;
				$this->write(
					"<option value='$value'".($selected ? " selected" : "")."> $label </option>"
				);
			}
			$this->write("</select>");
		}

		function renderReadonly () {
			$variable = $this->getValue();
			if (!is_array($variable)) {
				CControl::renderReadonly();
			}
			else {
				$strval = $comma = "";
				foreach ($variable as $value) {
					$this->write("<input name='{$this->name}[]' type='hidden' value='$value'>");
					$strval .= "$comma$value";
					$comma = ",";
				}
				$this->write($strval);
			}
		}
	}
?>