<?php
	/**
	 * DB interface module to MySQL.
	 * @module	mysql.phps
	 * @package	PHP/Toolbox
	 *//*'*************************************************\
	 	Copyright (C) 2001, Alexey Ilyin

	 	This library is free software; you can
		redistribute it and/or modify it under the terms
		of the GNU Lesser General Public License as
		published by the Free Software Foundation; either
		version 2.1 of the License, or (at your option)
		any later version.

	 	This library is distributed in the hope that it
		will be useful, but WITHOUT ANY WARRANTY; without
		even the implied warranty of MERCHANTABILITY or
		FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
		Lesser General Public License for more details.

	 	You should have received a copy of the GNU Lesser
		General Public License along with this library; if
		not, write to the Free Software Foundation, Inc.,
		59 Temple Place, Suite 330, Boston, MA 02111-1307
		USA

	 	ai@a4web.com
	 	www.a4web.com
	\**************************************************/

	/**	Checks if result of most recent query is successful.
	 * 	It invokes func::phpx_assert().
	 * 	@param	int	- xxx_query() result.
	 * 	@param	string	- the string to append to log.
	 */
	function  check_db_error ($result = TRUE, $postfix = "--") {
		phpx_assert($result && !mysql_errno(), "mysql_error:\t".mysql_error()."\t$postfix");
	}

	/**	Performs the db query and checks the errors.
	 * 	<xmp>
	 |	$rset = do_query (
	 |		"select * from table ..."
	 |	);
	 |	while (fetch_object($rset, $rec)) {
	 |		...
	 |	}
	 |	free_result($rset);
	 * 	</xmp>
	 * 	@param	string	- SQL statement.
	 * 	@return	int	- query result (recordset).
	 */
	function do_query ($sql)
		/*** template  ***\
		$rset = do_query (
			"`sql`"
		);
		while (fetch_object($rset, $rec)) {
			`statement`
		}
		free_result($rset);
		/*****************/
	{
		$rset = mysql_query($sql);
		check_db_error($rset, "($sql)");
		return $rset;
	}

	/**	Fetches recordset as an array.
	 * 	<xmp>
	 |	$count = fetch_query (
	 |		"select * from table ..."
	 |  	$records
	 |  );
	 * 	</xmp>
	 * 	@param	string	- SQL statement.
	 * 	@param	array	- [out] record array.
	 * 	@param	int		- what each record is.
	 * 	Useful to fetch *small* recordset only!
	 */
	function fetch_query ($sql, &$result, $mode=MYSQL_ASSOC)
		/*** template  ******\
		$count = fetch_query (
			"`sql`"
			$table
		);
		/********************/
	{
		$result = array();
		$rset = do_query ($sql);
		while (fetch_record($rset, $rec, $mode)) {
			$result[] = $rec;
		}
		free_result($rset);
		return count($result);
	}

	/**	Returns row number from recordset.
	 * 	@param	int	- record set.
	 * 	@return	int	- row number.
	 */
	function rset_rows ($rset) {
		return mysql_num_rows($rset);
	}

	/**	Disposes the recordset.
	 * 	@param	int	- the recordset to dispose.
	 */
	function free_result ($rset) {
		mysql_free_result($rset);
	}

	/**	Fetches next record as a hash.
	 * 	@param	int		- recordset.
	 * 	@param	array	- [out] record.
	 * 	@param	int		- what the record is.
	 * 	@return	mixed	- non-0 on success.
	 */
	function fetch_record ($rset, &$result, $mode=MYSQL_ASSOC) {
		return $result = mysql_fetch_array($rset, $mode);
	}

	/**	Fetches next record as a object.
	 * 	@param	int		- recordset.
	 * 	@param	object	- [out] record.
	 * 	@param	int		- what the record is.
	 * 	@return	mixed	- non-0 on success.
	 */
	function fetch_object ($rset, &$result, $mode=MYSQL_ASSOC) {
		return $result = mysql_fetch_object($rset, $mode);
	}

	/**	Fetches field metainfo.
	 * 	The output field contains at least thwo members:
	 * 	<ul>
	 * 	<li>	name
	 * 	<li>	type
	 * 	</ul>
	 * 	@param	int		- recordset.
	 * 	@param	object	- [out] field.
	 * 	@param	int.
	 * 	@return	mixed	- non-0 on success.
	 */
	function fetch_field ($rset, &$field, $i) {
		return $field = mysql_fetch_field($rset);
	}

	/**	Returns array of database table names matching to wildcard.
	 * 	@param	string	- whildcard.
	 * 	@param	array	- [out] names.
	 * 	@return	int		- names count.
	 */
	function show_tables_like ($wild, &$result) {
		$result = array();
		$rset = do_query ("show tables like '$wild'");
		while (fetch_record($rset, $rec, MYSQL_NUM)) {
			$result[] = $rec[0];
		}
		mysql_free_result($rset);
		return count($result);
	}

	/**	Database-specific crypt function. */
	function sql_crypt ($pwd, $salt = "") {
		$result = mysql_query("select password('$pwd')");
		phpx_assert($row = mysql_fetch_row($result), FATAL_CRYPT_ERROR);
		mysql_free_result($result);
		return $row[0];
	}

?>