<?php
	/**
	 * DB interface module to PostgreSQL.
	 * @module	pgsql.phps
	 * @package	PHP/Toolbox
	 *//*'*************************************************\
	 	Copyright (C) 2001, Alexey Ilyin

	 	This library is free software; you can
		redistribute it and/or modify it under the terms
		of the GNU Lesser General Public License as
		published by the Free Software Foundation; either
		version 2.1 of the License, or (at your option)
		any later version.

	 	This library is distributed in the hope that it
		will be useful, but WITHOUT ANY WARRANTY; without
		even the implied warranty of MERCHANTABILITY or
		FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
		Lesser General Public License for more details.

	 	You should have received a copy of the GNU Lesser
		General Public License along with this library; if
		not, write to the Free Software Foundation, Inc.,
		59 Temple Place, Suite 330, Boston, MA 02111-1307
		USA

	 	ai@a4web.com
	 	www.a4web.com
	\**************************************************/

	function  check_db_error ($result = TRUE, $postfix = "--") {
		$errmsg = pg_errormessage();
		phpx_assert($result && !errmsg, "pgsql_error:\t".$errmsg."\t$postfix");
	}

	function do_query ($sql)
		/*** template  ***\
		$rset = do_query (
			"`sql`"
		);
		while (fetch_object($rset, $rec)) {
			`statement`
		}
		free_result($rset);
		/*****************/
	{
		global $PGSQL_CONN;
		$rset = pg_exec($PGSQL_CONN, $sql);
		check_db_error($rset, "($sql)");
		return $rset;
	}

	/**	useful to fetch *small* recordset only!
	 */
	function fetch_query ($sql, &$result, $mode=PGSQL_ASSOC)
		/*** template  ******\
		$count = fetch_query (
			"`sql`"
			$table
		);
		/********************/
	{
		$result = array();
		$rset = do_query ($sql);
		while (fetch_record($rset, $rec, $mode)) {
			$result[] = $rec;
		}
		free_result($rset);
		return count($result);
	}

	function rset_rows ($rset) {
		return pg_numrows($rset);
	}

	function free_result ($rset) {
		pg_freeresult($rset);
	}

	if (!defined("PGSQL_RESULT_ROW")) {
		/**	Current result row
		 * 	to use in fetch functions.
		 * 	@see fetch_record(), fetch_object()
		 */
		define("PGSQL_RESULT_ROW", "_P_R_R_");
	}

	function fetch_record ($rset, &$result, $mode=PGSQL_ASSOC) {
		$row = @$result[PGSQL_RESULT_ROW];
		$result = pg_fetch_array($rset, $row++, $mode);
		$result[PGSQL_RESULT_ROW] = $row;
		return $result;
	}

	function fetch_object ($rset, &$result, $mode=MYSQL_ASSOC) {
		$row = @$result[PGSQL_RESULT_ROW];
		$result = pg_fetch_object($rset, @$result[PGSQL_RESULT_ROW], $mode);
		$result[PGSQL_RESULT_ROW] = $row;
		return $result;
	}

	function fetch_field ($rset, &$field, $i) {
		$tmp["name"]	= pg_fieldname($rset, $i);
		$tmp["type"]	= pg_fieldtype($rset, $i);
		$tmp["size"]	= pg_fieldsize($rset, $i);
		//$tmp[""]	= ;
		return $field = (object)$tmp;
	}

	function show_tables_like ($wild, &$result) {
		$result = array();
		$rset = do_query ("show tables like '$wild'");
		while (fetch_record($rset, $rec, PGSQL_NUM)) {
			$result[] = $rec[0];
		}
		free_result($rset);
		return count($result);
	}

	/**	Database-specific crypt function. */
	function sql_crypt ($pwd, $salt = "") {
		return md5($pwd);
	}

?>