<?php
	/*'***************************************************\
		PHP4/X SAMPLE ADMIN INTERFACE.
		@author: Alexey Ilyin [ai@a4web.com]
	 ****************************************************
	 	Copyright (C) 2001, Alexey Ilyin

	 	This library is free software; you can
		redistribute it and/or modify it under the terms
		of the GNU Lesser General Public License as
		published by the Free Software Foundation; either
		version 2.1 of the License, or (at your option)
		any later version.

	 	This library is distributed in the hope that it
		will be useful, but WITHOUT ANY WARRANTY; without
		even the implied warranty of MERCHANTABILITY or
		FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
		Lesser General Public License for more details.

	 	You should have received a copy of the GNU Lesser
		General Public License along with this library; if
		not, write to the Free Software Foundation, Inc.,
		59 Temple Place, Suite 330, Boston, MA 02111-1307
		USA

	 	ai@a4web.com
	 	www.a4web.com
	\****************************************************/

	require_once "cdbtabform.phps";
	require_once "cformhandlertabbed.phps";
	require_once "cbutton.phps";
	require_once "cgroup.phps";
	require_once "ctextarea.phps";
	require_once "ccfile.phps";

	class CFormHandlerTabbedDB extends CFormHandlerTabbed {
		function start (&$form) {
			global $DO;
			return CFormHandlerTabbed::start($form)
				."<tr><th class=nolabel colspan=2>&nbsp;$DO&nbsp;</th></tr>";
		}
	}

	class CUnixTimeMs extends CControl {
		function CUnixTimeMs ($attrs) {
			$this->CControl($attrs);
			$this->ValidateAsInteger = FALSE;
			$this->ValidateAsRegex = INVALID_DATE;
			$this->ValidationRegex = '^(none|[0-9]+-[0-9]+-[0-9]+( [0-9]+:[0-9]+(:[0-9]+)?)*)$';
		}

		function inValue ($unixtime) {
			return (0 < $unixtime && $unixtime < MAXBIGINT) ? date("Y-m-d H:i:s", $unixtime/1000) : "none";
		}

		function outValue () {
			$date = CControl::outValue();
			if (empty($date) || $date === "none") return 0;
			sscanf($date, "%d-%d-%d %d:%d:%d", $Y, $m, $d, $H, $i, $s);
			return 1000*mktime($H, $i, $s, $m, $d, $Y);
		}
	}

	function stdProcessForm (&$form, &$do, &$where) {
		global	$submit, $cancel, $referer;
		if (isset($cancel)) {
			header("Location: $referer");
			exit;
		}
		$form->addSubmitCancel();
		if (isset($submit)) {
			$form->addVars("HTTP_POST_VARS");
			if ($form->validateValues()) {
				if (!defined("FORM_CONFIRMAITON_STYLE")
					|| $form->setMode(FORM_CONFIRMAITON_STYLE) == FORM_CONFIRMAITON_STYLE) {
					return TRUE;
				}
			}
		}
		else {
			if ($do != "INS" && $where) {
				if ($do == "DEL") $form->setMode("Readonly");
				$form->fetchValues (base64_decode($where));
			}
			$form->addVars("HTTP_GET_VARS");
		}
		return FALSE;
	}

	$COMMON_CONTROLS = array (
		"id"	=> new CControl(array(
			"dontadd"	=> TRUE,
			"label"		=> "ID",
			"type"		=> @$DO == "INS" ? "text" : "hidden",
			"default"	=> 0
		)),
		"uri"	=> new CControl(array(
			"dontadd"	=> TRUE,
			"label"		=> "URI",
			"attrs"		=> "SIZE=50"
		)),
		"target" => new CGroup(array (
			"dontadd"	=> TRUE,
			"label"		=> "Target URI mask (+)",
			"lookup"	=> "uri_mask as op_label, uid as op_value from pe_targets"
		)),
		"stat"	=> new CGroup(array(
			"dontadd"	=> TRUE,
			"label"		=> "Status",
			"options"	=> "none|active|busy|suspended|invalid",
			"default"	=> "none"
		)),
		"text"	=> new CTextarea(array(
			"dontadd"	=> TRUE,
			"ignore"	=> FALSE,
			"attrs"		=> "COLS=80, ROWS=15"
		)),
		"time"	=> new CUnixTimeMs(array(
			"dontadd"	=> TRUE,
			"label"		=> "Start"
		)),
		"icon"	=> new CCFile(array(
			"dontadd"	=> TRUE,
			"do"		=> @$DO,
			"upload_dir"=> PROJECT_UPLOAD_DIR,
			"abs_path"	=> $DOCUMENT_ROOT
		))
	);
?>