<?php
	/*'************************************************\
		PHP/Toolbox::TestSuite
		Test CDBTabForm
	\**************************************************/

	require_once "cdbtabform.phps";
	require_once "cformhandlertabbed.phps";
	require_once "ccontrol.phps";
	require_once "cgroup.phps";
	require_once "cbutton.phps";
	require_once "func.phps";
	require_once "connect.inc";

	$form = new CDBTabForm("Tabbed", "user", "$PHP_SELF", "POST");
	$form->build(array(
		"password" => new CControl(array(
			"type"		=> "password",
			"ignore"	=> TRUE
		))
	));

	define	("FORM_CONFIRMAITON_STYLE", "Readonly");

	/**	Standard form process logic.
	 */
	function stdProcessForm (&$form, &$do, &$where) {
		global	$submit, $cancel, $referer;
		if (isset($cancel)) {
			header("Location: $referer");
			exit;
		}
		$form->addSubmitCancel();
		if (isset($submit)) {
			$form->addVars("HTTP_POST_VARS");
			if ($form->validateValues()) {
				if (!defined("FORM_CONFIRMAITON_STYLE")
					|| $form->setMode(FORM_CONFIRMAITON_STYLE) == FORM_CONFIRMAITON_STYLE) {
					return TRUE;
				}
			}
		}
		else {
			if ($do != "INS" && $where) {
				if ($do == "DEL") $form->setMode("Readonly");
				$form->fetchValues (base64_decode($where));
			}
			$form->addVars("HTTP_GET_VARS");
		}
		return FALSE;
	}

	if (stdProcessForm($form, $DO, $WHERE)) {
		switch ($DO) {
		case "INS" :
			do_query("replace $form->table set ".$form->SetList());
			break;
		case "EDIT" :
			do_query("update  $form->table set ".$form->SetList()." where ".base64_decode($WHERE));
			break;
		case "DEL" :
			do_query("delete  from $form->table where ".base64_decode($WHERE));
			break;
		}
		header("Location: $referer");
		exit;
	}
?>
<html>
<head>
<style>
<!--
body { background-color: #CCCCCC; }
.nolabel, .backcell	{text-align:center;	vertical-align: middle;	background:#666666;	color: #FFFFFF;}
.label 		{ text-align: right; vertical-align: middle; background:#dddddd; font-weight : bold;}
.required	{ text-align: right; vertical-align: middle; background:#dddddd; color: #660000; font-weight : bold;}
.field 		{text-align: left;	vertical-align: middle;	background:#bbbbbb;}
-->
</style>
</style>
</head>
<body>
<h1>CDBTabForm</h1>
<?php $form->render() ?>
</body>
</html>